<!doctype html>
<html lang="en">
<head>
    <title>Go Programming Language</title>
    <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <meta http-equiv="Cache-Control" content="no-cache, no-store, must-revalidate"/>
  <link rel="shortcut icon" href="/assets/img/logo.png" type="image/png">
  <meta http-equiv="Pragma" content="no-cache"/>
  <meta http-equiv="Expires" content="0"/>
  <!-- link rel="shortcut icon" href="/assets/img/logo.png" type="image/png"-->
  <link rel="stylesheet" href="/assets/styles.css">
</head>
<body>
<header class=nav-bar>
  <nav>
    <div class=sidebar-button></div>
    <!--div id=bwtoggle></div-->
    <a class="homelink spy" href="/">r<span class=hideable>wx.gg</span></a>
    <div class="nav-right">
      <!-- div id=search-box></div -->
      <ul class=nav-links>
        <li class=nav-item><a class=nav-link href="/boost/">Boosts</a></li>
        <!--
        <li class=nav-item><a class=nav-link href="/how/">HowTos</a></li>
        <li class=nav-item><a class=nav-link href="/contrib/">Contribute</a></li>
        -->
        <li class=nav-item><a class="nav-link" href="https://gitlab.com/rwx.gg/README">GitLab</a></li>
        <li class=nav-item><a class="nav-link" href="https://www.youtube.com/rwxrob">YouTube</a></li>
        <li class=nav-item><a class="nav-link" href="https://discord.gg/9wydZXY">Discord</a></li>
        <li class=nav-item><a class="nav-link" href="https://twitch.tv/rwxrob">Twitch</a></li>
      </ul>
    </div>
  </nav>
</header>
<main id=top>
<div class=container>  <h1 id=title>Go Programming Language</h1>
  <p>Go is a programming language designed originally to replace Python, Java, C/C++ at Google by some of the most experienced engineers who have ever lived, <a href="https://duck.com/lite?kd=-1&amp;kp=-1&amp;q=Rob%20Pike">Rob Pike</a>, <a href="https://duck.com/lite?kd=-1&amp;kp=-1&amp;q=Ken%20Thompson">Ken Thompson</a>, and <a href="https://duck.com/lite?kd=-1&amp;kp=-1&amp;q=Robert%20Griesemer">Robert Griesemer</a>. It was specifically created to handle <em>most</em> high-performance utilitarian software development needs at Google. Forged in the white-hot fires of enterprise to slay many very real problems, it’s no surprise this light, fast, and solid tool is a popular and ideal choice for most back-end work. Go should be considered required learning by any serious technologist because of its efficiency, ubiquity, versatility, and sustainability which is why it is the most significant language of the DevOps movement and in 2017 <a href="https://www.forbes.com/sites/laurencebradford/2017/09/22/the-2-highest-paying-programming-languages-you-maybe-never-heard-of">Forbes called it</a> one of the “two highest paid languages you maybe never have heard of,” three years after TJ Holowaychuk <a href="https://medium.com/code-adventures/farewell-node-js-4ba9e7f3e52b">switched to Go</a> from Node.</p>
  <h2 id="learning-go">Learning Go</h2>
  <p>Learning Go is one of the most rewarding activities you can pursue. The best way to learn it is to start writing code in it, even the simplest code. You can use the <a href="/lang/cha/">language challenges</a> to get some ideas.</p>
  <p>However, when it comes to books, courses, and other materials there is no real solid leader. Perhaps the best approach is to simply read the documentation created by the Go team itself. Consider reading these in the order suggested by the Go team:</p>
  <ol type="1">
  <li><a href="https://golang.org/ref/spec">The Go Programming Language Specification</a></li>
  <li><a href="/lang/go/tour/">Tour of Go</a></li>
  <li><a href="https://golang.org/doc/code.html">How to Write Go Code</a></li>
  <li><a href="https://golang.org/doc/effective_go.html">Effective Go</a></li>
  </ol>
  <p>Don’t forget to start a <a href="/what/codebook/">codebook</a> and get busy trying out the code you are reading about. It’s the only way to remember it.</p>
  <h2 id="videos">Videos</h2>
  <p>Here are some of videos good for beginners:</p>
  <ul>
  <li><a href="https://youtu.be/Ot9Em123Fz8">How to Start a Golang Project Right</a></li>
  </ul>
  <h2 id="frequently-answered-questions">Frequently Answered Questions</h2>
  <h4 id="i-hate-gos-reserve-type-syntax">“I hate Go’s reserve type syntax!”</h4>
  <p>Um, that’s not a question. Get over it. It’s far superior for several <a href="https://blog.golang.org/declaration-syntax">objective reasons</a>.</p>
  <p><em>This is also why Rust uses it, by the way.</em></p>
  <h2 id="see-also">See Also</h2>
  <ul>
  <li><a href="https://golangresources.com" class="uri">https://golangresources.com</a></li>
  <li><a href="https://www.youtube.com/channel/UC-JTtk2nEdWPZTUDOPwEYbg">Junmin Lee, Go Tutorials</a></li>
  <li><a href="https://github.com/golang/go/wiki/CodeReviewComments">Go Code Review Comments</a></li>
  <li><a href="https://github.com/betty200744/ultimate-go">Ultimate Go</a></li>
  <li><a href="https://www.golang-book.com/">Introduction to Go Programming</a></li>
  <li><a href="https://openmymind.net/The-Little-Go-Book">The Little Go Book</a></li>
  <li><a href="https://www.digitalocean.com/community/books/how-to-code-in-go-ebook">How to Code in Go</a></li>
  <li><a href="https://headfirstgo.com">Head First Go</a></li>
  <li><a href="http://www.golangbootcamp.com/">Go Bootcamp</a></li>
  <li><a href="http://www.miek.nl/go">Learning Go</a></li>
  <li><a href="https://github.com/pazams/go-for-javascript-developers">Go for JavaScript Developers</a></li>
  <li><a href="https://www.manning.com/books/go-in-action">Go in Action</a></li>
  <li><a href="https://leanpub.com/golang-tdd">Test-Driven Development with Go</a></li>
  <li><a href="https://checkmarx.gitbooks.io/go-scp/content/">Go Secure Coding Practices</a></li>
  <li><a href="https://www.apress.com/us/book/9781484226919">Network Programming with Go</a></li>
  <li><a href="https://www.manning.com/books/go-in-practice">Go in Practice</a></li>
  <li><a href="https://leanpub.com/GoNotebook/">A Go Developer’s Notebook</a></li>
  <li><a href="https://www.informit.com/store/go-programming-language-phrasebook-9780321817143">The Go Programming Language Phrasebook</a></li>
  <li><a href="https://nostarch.com/blackhatgo">Black Hat Go</a></li>
  <li><a href="https://www.oreilly.com/library/view/concurrency-in-go/9781491941294/">Concurrency in Go</a></li>
  <li><a href="https://leanpub.com/api-foundations">API Foundations in Go</a></li>
  <li><a href="https://github.com/thewhitetulip/web-dev-golang-anti-textbook">Web Apps in Go, the Anti-Textbook</a></li>
  <li><a href="https://www.manning.com/books/go-web-programming">Go Web Programming</a></li>
  <li><a href="https://www.usegolang.com/">Learn to Create Web Applications Using Go</a></li>
  <li><a href="https://leanpub.com/12fa-docker-golang">12 Factor Applications with Docker and Go</a></li>
  <li><a href="https://buildsaasappingo.com">Build SaaS Apps in Go</a></li>
  <li><a href="https://lets-go.alexedwards.net/">Let’s Go</a></li>
  <li><a href="https://tutorialedge.net/course/golang/">Tutorial Edge Course</a></li>
  <li><a href="https://www.coursera.org/specializations/google-golang/">Programming with Google Go Specialization</a></li>
  <li><a href="https://go.dev" class="uri">https://go.dev</a></li>
  <li><a href="https://tour.golang.org" class="uri">https://tour.golang.org</a> <em>(Despite the horrible JavaScript-only site.)</em></li>
  <li><a href="https://medium.com/golang-learn/go-project-layout-e5213cdcfaa2">Go Project Layout</a></li>
  </ul>
</main>
<footer>
  <p><a href="/copyright/" id=copyright>© 2020 Rob Muhlestein. Licensed under Creative Commons Attribution-ShareAlike.</a><br/>Does something seem to have changed? <a href="/changes/">Check the change log</a>.
  <br>See something wrong? <a class="nodecor" href="https://gitlab.com/rwx.gg/README/-/issues">Open a ticket</a>.
  </p>
</footer>
<script src="/assets/main.js"></script>
</body>
</html>